﻿package  {
	import flash.display.Sprite;
	import flash.ui.Keyboard;
    import flash.events.*;
    import flash.utils.*;
	import flash.display.Bitmap;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	
	public class testclass extends Sprite {
		
		var guy:Player;
		var timer:Timer;
		var enemyarray:Array;
		var enemygrafixarray:Array;
		
		[Embed(source='art\\background.png')]
		public var grafixdata0:Class;
		public var grafix0:Bitmap = new grafixdata0();
		
		[Embed(source='music\\main.mp3')] 		 
		private var bgmusicdata:Class;
		private var bgmusic:Sound = new bgmusicdata();
		
		[Embed(source='music\\start.mp3')] 		 
		private var startdata:Class;
		private var start:Sound = new startdata();
		
		[Embed(source='music\\end.mp3')] 		 
		private var enddata:Class;
		private var end:Sound = new enddata();
		
		private var sc:SoundChannel;
		
		public function testclass() {
			trace("game loaded");
			sc = start.play(0,1);
			sc.addEventListener(Event.SOUND_COMPLETE,startbgmusic);
			graphics.beginBitmapFill(grafix0.bitmapData);
			graphics.drawRect(0,0,550,400);
			graphics.endFill();
			guy = new Player(250,340);
			this.addChild(guy);
			
			if (stage != null) {
				initKeys(null);
			} else {
				addEventListener(Event.ADDED_TO_STAGE, initKeys);
			}
			
			
			enemyarray = new Array();
			enemyarray.push(makeenemy());
			
			timer = new Timer(40);
			timer.addEventListener(TimerEvent.TIMER,update);
			timer.start();
		}
		
		public function initKeys(evt:Event) {
			stage.addEventListener(KeyboardEvent.KEY_DOWN,playermove);
		}
		
		public function startbgmusic(evt:Event) {
			sc.removeEventListener(Event.SOUND_COMPLETE,startbgmusic);
			sc=bgmusic.play(0,9999);
			
		}
		
		public function playermove(e:KeyboardEvent) {
			if (e.keyCode == Keyboard.LEFT) {
				guy.x-=5;
			} else if (e.keyCode == Keyboard.RIGHT) {
				guy.x+=5;
			}
		}
		
		public function makeenemy():Enemy {
			var temp:Enemy = new Enemy(Math.random()*550,0);
			this.addChild(temp);
			return temp;
		}
		
		public function update(e:TimerEvent) {
			for each(var en:Enemy in enemyarray) {
				en.y+=5;
				if (guy.hitTestObject(en)) {
					sc.stop();
					sc = end.play(0,1);
					timer.stop();
					stage.removeEventListener(KeyboardEvent.KEY_DOWN,playermove);
				}
				if (en.y > 550) {
					this.removeChild(en);
					enemyarray.splice(enemyarray.indexOf(en),1);
				}
			}
			if (Math.round(Math.random()*20) == 1) {
				enemyarray.push(makeenemy());
			}
		}

	}
	
}
